// WCCDlg.cpp : implementation file
#include "stdafx.h"
#include "WCC.h"
#include "WCCDlg.h"
#include "ChessClock.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CAboutDlg Implementation
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CMoretimeDlg Implementation
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CMoretimeDlg::CMoretimeDlg(int mp) : CDialog(CMoretimeDlg::IDD)
{
	iWho = 0;
	iTime = 0;
	iMaxPlayers = mp;
}

void CMoretimeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, RAD_ALL, chkAll);
	DDX_Control(pDX, RAD_PLAYER, chkSpecific);
	DDX_Control(pDX, CMB_PLAYER, cmbPlayer);
	DDX_Control(pDX, EDT_MIN, edtMin);
	DDX_Control(pDX, EDT_S, edtS);
}

BOOL CMoretimeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	chkAll.SetCheck(true);
	edtMin.SetLimitText(3);
	edtS.SetLimitText(3);
	edtMin.SetWindowText("1");
	edtS.SetWindowText("0");
	for (int i=1; i<=iMaxPlayers; i++) {
		cmbPlayer.AddString(i2str(i).c_str());
	}
	return TRUE;
}

void CMoretimeDlg::OnBnClickedOk()
{
	iWho = chkAll.GetCheck() ? 0 : str2i(GetTxt(cmbPlayer));
	iTime = str2i(GetTxt(edtMin)) * 60 + str2i(GetTxt(edtS));
	OnOK();
}

void CMoretimeDlg::OnCbnSelchangePlayer()
{
	chkSpecific.SetCheck(true);
	chkAll.SetCheck(false);
}

BEGIN_MESSAGE_MAP(CMoretimeDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CMoretimeDlg::OnBnClickedOk)
	ON_CBN_SETFOCUS(CMB_PLAYER, &CMoretimeDlg::OnCbnSelchangePlayer)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CPlayersDlg Implementation
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPlayersDlg::CPlayersDlg(int p) : CDialog(CPlayersDlg::IDD)
{
	iPlayers = p;
}

BOOL CPlayersDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	switch (iPlayers) {
		case 1: chk1.SetCheck(true); break;
		case 2: chk2.SetCheck(true); break;
		case 3: chk3.SetCheck(true); break;
		case 4: chk4.SetCheck(true); break;
		case 5: chk5.SetCheck(true); break;
		case 6: chk6.SetCheck(true); break;
	}
	return TRUE;
}

void CPlayersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, RAD_1, chk1);
	DDX_Control(pDX, RAD_2, chk2);
	DDX_Control(pDX, RAD_3, chk3);
	DDX_Control(pDX, RAD_4, chk4);
	DDX_Control(pDX, RAD_5, chk5);
	DDX_Control(pDX, RAD_6, chk6);
}

void CPlayersDlg::OnBnClickedOk()
{
	iPlayers = chk1.GetCheck() ? 1 : chk2.GetCheck() ? 2 : chk3.GetCheck() ? 3 : chk4.GetCheck() ? 4 : chk5.GetCheck() ? 5 : chk6.GetCheck() ? 6 : 0;
	OnOK();
}

BEGIN_MESSAGE_MAP(CPlayersDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CPlayersDlg::OnBnClickedOk)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CWCCDlg dialog
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CWCCDlg::CWCCDlg(CWnd* pParent /*=NULL*/): CDialog(CWCCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_font.CreatePointFont(800,"Verdana"); 
	m_bInitialized = false;
}

void CWCCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, BTN_PRESS1, btnPress1);
	DDX_Control(pDX, BTN_PRESS2, btnPress2);
	DDX_Control(pDX, BTN_1, btn1);
	DDX_Control(pDX, BTN_2, btn2);
	DDX_Control(pDX, BTN_3, btn3);
	DDX_Control(pDX, BTN_4, btn4);
	DDX_Control(pDX, BTN_5, btn5);
	DDX_Control(pDX, BTN_6, btn6);
	DDX_Control(pDX, BTN_PAUSE, btnPause);
	DDX_Control(pDX, BTN_RESET, btnReset);
	DDX_Control(pDX, BTN_NEXT, btnNext);
	DDX_Control(pDX, EDT_TIME, edtTime);
	DDX_Control(pDX, EDT_INC, edtInc);
	DDX_Control(pDX, EDT_PLAYER1, edtPlayer1);
	DDX_Control(pDX, EDT_PLAYER2, edtPlayer2);
	DDX_Control(pDX, EDT_PLAYER3, edtPlayer3);
	DDX_Control(pDX, EDT_PLAYER4, edtPlayer4);
	DDX_Control(pDX, EDT_PLAYER5, edtPlayer5);
	DDX_Control(pDX, EDT_PLAYER6, edtPlayer6);
	DDX_Control(pDX, CHK_BRONSTEIN, chkBronstein);
	DDX_Control(pDX, LBL_CLOCK1, lblClock1);
	DDX_Control(pDX, LBL_CLOCK2, lblClock2);
	DDX_Control(pDX, LBL_CLOCK3, lblClock3);
	DDX_Control(pDX, LBL_CLOCK4, lblClock4);
	DDX_Control(pDX, LBL_CLOCK5, lblClock5);
	DDX_Control(pDX, LBL_CLOCK6, lblClock6);
	DDX_Control(pDX, CHK_SOUND, chkSound);
	DDX_Control(pDX, BTN_MORETIME, btnMoretime);
	DDX_Control(pDX, BTN_PLAYERS, btnPlayers);
	DDX_Control(pDX, LBL_PRESSED1, lblPressed1);
	DDX_Control(pDX, LBL_PRESSED2, lblPressed2);
	DDX_Control(pDX, LBL_PRESSED3, lblPressed3);
	DDX_Control(pDX, LBL_PRESSED4, lblPressed4);
	DDX_Control(pDX, LBL_PRESSED5, lblPressed5);
	DDX_Control(pDX, LBL_PRESSED6, lblPressed6);
}

BEGIN_MESSAGE_MAP(CWCCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(BTN_PRESS1, &CWCCDlg::OnBnClickedPress1)
	ON_BN_CLICKED(BTN_PRESS2, &CWCCDlg::OnBnClickedPress2)
	ON_BN_CLICKED(BTN_RESET, &CWCCDlg::OnBnClickedReset)
	ON_BN_CLICKED(BTN_PAUSE, &CWCCDlg::OnBnClickedPause)
	ON_BN_CLICKED(BTN_MORETIME, &CWCCDlg::OnBnClickedMoretime)
	ON_BN_CLICKED(BTN_PLAYERS, &CWCCDlg::OnBnClickedPlayers)
	ON_BN_CLICKED(BTN_NEXT, &CWCCDlg::OnBnClickedNext)
	ON_BN_CLICKED(BTN_1, &CWCCDlg::OnBnClicked1)
	ON_BN_CLICKED(BTN_2, &CWCCDlg::OnBnClicked2)
	ON_BN_CLICKED(BTN_3, &CWCCDlg::OnBnClicked3)
	ON_BN_CLICKED(BTN_4, &CWCCDlg::OnBnClicked4)
	ON_BN_CLICKED(BTN_5, &CWCCDlg::OnBnClicked5)
	ON_BN_CLICKED(BTN_6, &CWCCDlg::OnBnClicked6)
	ON_BN_CLICKED(CHK_BRONSTEIN, &CWCCDlg::OnBnClickedBronstein)
	ON_EN_CHANGE(EDT_INC, &CWCCDlg::OnEnChangeInc)
	ON_EN_CHANGE(EDT_TIME, &CWCCDlg::OnEnChangeTime)
END_MESSAGE_MAP()

BEGIN_EASYSIZE_MAP(CWCCDlg)
	//EASYSIZE(control,left,top,right,bottom,options)
	EASYSIZE(BTN_PRESS1,ES_BORDER,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(BTN_PRESS2,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)

	EASYSIZE(BTN_RESET,ES_BORDER,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(BTN_PAUSE,ES_BORDER,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(BTN_NEXT,ES_BORDER,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(BTN_MORETIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
	EASYSIZE(BTN_PLAYERS,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)
	EASYSIZE(CHK_SOUND,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,ES_BORDER,0)

	EASYSIZE(EDT_TIME,ES_BORDER,ES_KEEPSIZE,ES_BORDER,ES_BORDER,ES_HCENTER)
	EASYSIZE(EDT_INC,ES_BORDER,ES_KEEPSIZE,ES_BORDER,ES_BORDER,ES_HCENTER)
	EASYSIZE(LBL_TIME,EDT_TIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(LBL_INC,EDT_TIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(LBL_MIN,EDT_TIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(LBL_S,EDT_TIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
	EASYSIZE(CHK_BRONSTEIN,EDT_TIME,ES_KEEPSIZE,ES_KEEPSIZE,ES_BORDER,0)
END_EASYSIZE_MAP

ChessClock clock1(VK_ESCAPE),clock2(VK_ADD),clock3(0),clock4(0),clock5(0),clock6(0);

BOOL CWCCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	INIT_EASYSIZE;

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// extra initialization
	edtPlayer1.SetWindowText("Player One");
	edtPlayer2.SetWindowText("Player Two");
	edtPlayer3.SetWindowText("Player Three");
	edtPlayer4.SetWindowText("Player Four");
	edtPlayer5.SetWindowText("Player Five");
	edtPlayer6.SetWindowText("Player Six");

	edtTime.SetLimitText(3);
	edtInc.SetLimitText(3);
	edtTime.SetWindowText("5");
	edtInc.SetWindowText("0");
	m_iTimer1 = SetTimer(1,94,NULL);
	m_iTimer2 = SetTimer(2,94,NULL);
	m_iTimer3 = SetTimer(3,94,NULL);
	m_iTimer4 = SetTimer(4,94,NULL);
	m_iTimer5 = SetTimer(5,94,NULL);
	m_iTimer6 = SetTimer(6,94,NULL);

	m_iPlayers = 2;
	OnBnClickedReset();
	m_bInitialized = true;
	m_bChanged = false;
	m_iGlobalStatus = 0; //READY

	m_brush1.CreateSolidBrush(RGB(255,255,255));
	m_brush2.CreateSolidBrush(RGB(0,0,0));
	m_brush3.CreateSolidBrush(RGB(255,255,255));
	m_brush4.CreateSolidBrush(RGB(0,0,0));
	m_brush5.CreateSolidBrush(RGB(255,255,255));
	m_brush6.CreateSolidBrush(RGB(0,0,0));
	
	SetFontSize();

	Recalculate();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWCCDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (clock1.IsRunning() && nIDEvent == m_iTimer1) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock1.IsOver())
			clock1.Dec();
		if (clock1.GetTime() != GetTxt(lblClock1))
			lblClock1.SetWindowText(clock1.GetTime().c_str());
		if (clock1.IsOver()) {
			clock1.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0) 
				MessageBox(CString(GetTxt(edtPlayer1).c_str()) +" has been flagged!","Player 1 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	if (clock2.IsRunning() && nIDEvent == m_iTimer2) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock2.IsOver())
			clock2.Dec();
		if (clock2.GetTime() != GetTxt(lblClock2))
			lblClock2.SetWindowText(clock2.GetTime().c_str());
		if (clock2.IsOver()) {
			clock2.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0)
				MessageBox(CString(GetTxt(edtPlayer2).c_str()) +" has been flagged!","Player 2 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	if (clock3.IsRunning() && nIDEvent == m_iTimer3) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock3.IsOver())
			clock3.Dec();
		if (clock3.GetTime() != GetTxt(lblClock3))
			lblClock3.SetWindowText(clock3.GetTime().c_str());
		if (clock3.IsOver()) {
			clock3.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0) 
				MessageBox(CString(GetTxt(edtPlayer3).c_str()) +" has been flagged!","Player 3 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	if (clock4.IsRunning() && nIDEvent == m_iTimer4) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock4.IsOver())
			clock4.Dec();
		if (clock4.GetTime() != GetTxt(lblClock4))
			lblClock4.SetWindowText(clock4.GetTime().c_str());
		if (clock4.IsOver()) {
			clock4.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0)
				MessageBox(CString(GetTxt(edtPlayer4).c_str()) +" has been flagged!","Player 4 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	if (clock5.IsRunning() && nIDEvent == m_iTimer5) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock5.IsOver())
			clock5.Dec();
		if (clock5.GetTime() != GetTxt(lblClock5))
			lblClock5.SetWindowText(clock5.GetTime().c_str());
		if (clock5.IsOver()) {
			clock5.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0) 
				MessageBox(CString(GetTxt(edtPlayer5).c_str()) +" has been flagged!","Player 5 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	if (clock6.IsRunning() && nIDEvent == m_iTimer6) {
		m_iGlobalStatus = 1; // RUNNING
		if (!clock6.IsOver())
			clock6.Dec();
		if (clock6.GetTime() != GetTxt(lblClock6))
			lblClock6.SetWindowText(clock6.GetTime().c_str());
		if (clock6.IsOver()) {
			clock6.Stop();
			m_iGlobalStatus = 2; // PAUSED
			SetTitle();
			GetNextPlayer();
			if (m_iRunningClock != 0)
				MessageBox(CString(GetTxt(edtPlayer6).c_str()) +" has been flagged!","Player 6 Time Over",MB_ICONWARNING|MB_OK);
		}
	}

	CDialog::OnTimer(nIDEvent);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Button handlers
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CWCCDlg::OnBnClickedPress1()
{
	if (m_iPlayers != 2)
		return;

	if (m_iGlobalStatus == 2) { //PAUSED
		if (!clock2.IsOver()) {
			m_iRunningClock = 2;
			SetClockLabels();
		}
		MessageBox("Clock Paused","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iRunningClock == 2 && m_iGlobalStatus == 1)
		return;

	if (m_iGlobalStatus == 0) { //READY
		m_iGlobalStatus = 1; //RUNNING
		SetTitle();
	}

	if (chkSound.GetCheck() && !clock2.IsRunning())
		MessageBeep(MB_ICONASTERISK);

    clock1.Inc();
    clock1.Stop();
    clock2.Run();
	SetClockTimes();
	if (!clock2.IsOver()) {
		m_iRunningClock = 2;
		SetClockLabels();
	}
	m_bChanged = true;
}

void CWCCDlg::OnBnClickedPress2()
{
	if (m_iPlayers != 2)
		return;

	if (m_iGlobalStatus == 2) { //PAUSED
		if (!clock1.IsOver()) {
			m_iRunningClock = 1;
			SetClockLabels();
		}
		MessageBox("Clock Paused","Information", MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iRunningClock == 1 && m_iGlobalStatus == 1)
		return;

	if (m_iGlobalStatus == 0) { //READY
		m_iGlobalStatus = 1; //RUNNING
		SetTitle();
	}

	if (chkSound.GetCheck() && !clock1.IsRunning())
		MessageBeep(MB_ICONASTERISK);  // switching clocks

	clock2.Inc();
    clock2.Stop();
    clock1.Run();
	SetClockTimes();
	if (!clock1.IsOver()) {
		m_iRunningClock = 1;
		SetClockLabels();
	}
	m_bChanged = true;
}

void CWCCDlg::OnBnClickedReset()
{
	if (m_iGlobalStatus == 0 && !m_bChanged) // READY already
		return;
	
	if (chkSound.GetCheck())
		MessageBeep(MB_OK);

	StopAll();
	clock1.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	clock2.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	clock3.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	clock4.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	clock5.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	clock6.Init(str2i(GetTxt(edtTime)),str2i(GetTxt(edtInc)),chkBronstein.GetCheck()!=0);
	SetClockTimes();

	//two big buttons for two-player mode only
	btnPress1.ShowWindow(m_iPlayers == 2 ? SW_SHOW : SW_HIDE);
	btnPress2.ShowWindow(m_iPlayers == 2 ? SW_SHOW : SW_HIDE);

	//player 1 clock - always visible
	int show = SW_SHOW;
	lblPressed1.ShowWindow(show); lblClock1.ShowWindow(show); btn1.ShowWindow(show); edtPlayer1.ShowWindow(show);
    btn1.EnableWindow(show);

	//player 2 clock - visible if m_iPlayers > 1
	show = m_iPlayers > 1 ? SW_SHOW : SW_HIDE;
	lblPressed2.ShowWindow(show); lblClock2.ShowWindow(show); btn2.ShowWindow(show); edtPlayer2.ShowWindow(show);
    btn2.EnableWindow(show);

	//player 3 clock - visible if m_iPlayers > 2
	show = m_iPlayers > 2 ? SW_SHOW : SW_HIDE;
	lblPressed3.ShowWindow(show); lblClock3.ShowWindow(show); btn3.ShowWindow(show); edtPlayer3.ShowWindow(show);
    btn3.EnableWindow(show);

	//player 4 clock - visible if m_iPlayers > 3
	show = m_iPlayers > 3 ? SW_SHOW : SW_HIDE;
	lblPressed4.ShowWindow(show); lblClock4.ShowWindow(show); btn4.ShowWindow(show); edtPlayer4.ShowWindow(show);
    btn4.EnableWindow(show);

	//player 5 clock - visible if m_iPlayers > 4
	show = m_iPlayers > 4 ? SW_SHOW : SW_HIDE;
	lblPressed5.ShowWindow(show); lblClock5.ShowWindow(show); btn5.ShowWindow(show); edtPlayer5.ShowWindow(show);
    btn5.EnableWindow(show);

	//player 6 clock - visible if m_iPlayers > 5
	show = m_iPlayers > 5 ? SW_SHOW : SW_HIDE;
	lblPressed6.ShowWindow(show); lblClock6.ShowWindow(show); btn6.ShowWindow(show); edtPlayer6.ShowWindow(show);
    btn6.EnableWindow(show);

	m_iRunningClock = 1;
	m_iGlobalStatus = 0; //READY
	SetClockLabels();
	SetTitle();
	Recalculate();
	m_bChanged = false;
}

void CWCCDlg::OnBnClickedNext()
{
	if (m_iRunningClock == 0)
		return;
	
	if (m_iGlobalStatus == 0 || m_iGlobalStatus == 2) { //READY or PAUSED
		OnBnClickedPause();  // Next is the same as Run or Resume
		return;
	}
	
	IncClock();
	StopClock();
	GetNextPlayer();

	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks

	RunClock();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked1()
{
	if (m_iRunningClock == 1)
		return;
	if (clock1.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer1).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 1;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 1;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked2()
{
	if (m_iRunningClock == 2)
			return;
	if (clock2.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer2).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 2;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 2;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked3()
{
	if (m_iRunningClock == 3)
		return;
	if (clock3.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer3).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 3;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 3;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked4()
{
	if (m_iRunningClock == 4)
			return;
	if (clock4.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer4).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 4;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 4;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked5()
{
	if (m_iRunningClock == 5)
		return;
	if (clock5.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer5).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 5;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 5;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClicked6()
{
	if (m_iRunningClock == 6)
			return;
	if (clock6.IsOver()) {
		MessageBox(CString(GetTxt(edtPlayer6).c_str()) + " is flagged!","Information",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if (m_iGlobalStatus == 1) { //RUNNING
		IncClock();
		StopClock();
		m_iRunningClock = 6;
		RunClock();
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_ICONASTERISK);  // switching clocks
	m_iRunningClock = 6;
	SetClockLabels();
	m_bChanged = true;
}

void CWCCDlg::OnBnClickedPause()
{
	if (m_iRunningClock == 0)
		return;
	switch (m_iGlobalStatus) {
	case 0: // RUN pressed
		m_iGlobalStatus = 1;
		RunClock();
	break;
	case 1: // PAUSE pressed
		//pause2resume
		if (clock1.IsRunning()) {
			m_iRunningClock=1;
			clock1.Stop();
		}
		if (clock2.IsRunning()) {
			m_iRunningClock=2;
			clock2.Stop();
		}
		if (clock3.IsRunning()) {
			m_iRunningClock=3;
			clock3.Stop();
		}
		if (clock4.IsRunning()) {
			m_iRunningClock=4;
			clock4.Stop();
		}
		if (clock5.IsRunning()) {
			m_iRunningClock=5;
			clock5.Stop();
		}
		if (clock6.IsRunning()) {
			m_iRunningClock=6;
			clock6.Stop();
		}

		m_iGlobalStatus = 2; // PAUSE
		PauseAll();
	break;
	case 2: // RESUME pressed
		//resume2pause
		RunClock();
		m_iGlobalStatus = 1; //RUNNING
		UnpauseAll();
		break;
	}
	if (chkSound.GetCheck())
		MessageBeep(MB_OK);
	SetClockLabels();
	SetTitle();
}

void CWCCDlg::OnBnClickedMoretime()
{
	if (m_iRunningClock == 0)
		return;
	if (chkSound.GetCheck())
		MessageBeep(MB_OK);

	if (m_iGlobalStatus == 1) { //RUNNING
		m_iGlobalStatus = 2; //PAUSED
		SetTitle();
		StopAll();
	}

	CMoretimeDlg dlgMoretime(m_iPlayers);
	if (dlgMoretime.DoModal() == IDOK) {
		int iAdd = dlgMoretime.GetMoretime();
		if (dlgMoretime.GetWho() == 0) {
			clock1.Moretime(iAdd);
			clock2.Moretime(iAdd);
			clock3.Moretime(iAdd);
			clock4.Moretime(iAdd);
			clock5.Moretime(iAdd);
			clock6.Moretime(iAdd);
		}
		switch (dlgMoretime.GetWho()) {
			case 1:	clock1.Moretime(iAdd); break;
			case 2:	clock2.Moretime(iAdd); break;
			case 3:	clock3.Moretime(iAdd); break;
			case 4:	clock4.Moretime(iAdd); break;
			case 5:	clock5.Moretime(iAdd); break;
			case 6:	clock6.Moretime(iAdd); break;
		}
		m_bChanged = true;
		SetClockLabels();
	};
}

void CWCCDlg::OnBnClickedPlayers()
{
	if (chkSound.GetCheck())
		MessageBeep(MB_OK); 

	if (m_iGlobalStatus == 1) { //RUNNING
		m_iGlobalStatus = 2; //PAUSED
		SetTitle();
		StopAll();
	}

	CPlayersDlg dlgPlayers(m_iPlayers);
	if (dlgPlayers.DoModal() == IDOK) {
		int old = m_iPlayers;
		m_iPlayers = dlgPlayers.GetPlayers();
		if (old != m_iPlayers) {
			m_bChanged = true;
			OnBnClickedReset();
		}
	};
}

void CWCCDlg::OnBnClickedBronstein()
{
	m_bChanged = true;
}

void CWCCDlg::OnEnChangeInc()
{
	m_bChanged = true;
}

void CWCCDlg::OnEnChangeTime()
{
	m_bChanged = true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Clocks manipulating functions
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CWCCDlg::GetNextPlayer()
{
	//calculate next clock
	int count = 0;
	do {
		count++;
		m_iRunningClock++;
		if (m_iRunningClock > m_iPlayers)
			m_iRunningClock = 1;

		if (count>10) { //All flagged
			m_iRunningClock = 0;
			m_iGlobalStatus = 3;
			SetTitle();
			SetClockLabels();
			MessageBox("Everyone is flagged, we cannot continue! Your only option now is RESET.","Disaster!",MB_ICONERROR|MB_OK);
			return;
		}
	} while (IsOverClock());
	SetClockLabels();
}

void CWCCDlg::SetClockLabels()
{
	if (m_iRunningClock == 0) { // all flagged
		SetLabel(1,4); SetLabel(2,4); SetLabel(3,4); SetLabel(4,4); SetLabel(5,4); SetLabel(6,4);
		return;
	}

	if (m_iGlobalStatus == 0 || m_iGlobalStatus == 2) { // READY or PAUSED
		switch (m_iRunningClock) {
			case 1: 
				SetLabel(1,0); //clock 1 is ready, other clocks are stopped
				SetLabel(2,1); SetLabel(3,1); SetLabel(4,1); SetLabel(5,1); SetLabel(6,1);
			break;
			case 2: 
				SetLabel(2,0); 
				SetLabel(1,1); SetLabel(3,1); SetLabel(4,1); SetLabel(5,1); SetLabel(6,1);
			break;
			case 3: 
				SetLabel(3,0); 
				SetLabel(1,1); SetLabel(2,1); SetLabel(4,1); SetLabel(5,1); SetLabel(6,1);
			break;
			case 4: 
				SetLabel(4,0); 
				SetLabel(1,1); SetLabel(2,1); SetLabel(3,1); SetLabel(5,1); SetLabel(6,1);
			break;
			case 5: 
				SetLabel(5,0); 
				SetLabel(1,1); SetLabel(2,1); SetLabel(3,1); SetLabel(4,1); SetLabel(6,1);
			break;
			case 6: 
				SetLabel(6,0); 
				SetLabel(1,1); SetLabel(2,1); SetLabel(3,1); SetLabel(4,1); SetLabel(5,1);
			break;
		}
	}
	if (m_iGlobalStatus == 1) { //RUNNING
		switch (m_iRunningClock) {
			case 1: 
				SetLabel(1,2); //clock 1 is running, other clocks are waiting
				SetLabel(2,3); SetLabel(3,3); SetLabel(4,3); SetLabel(5,3); SetLabel(6,3);
			break;
			case 2: 
				SetLabel(2,2); 
				SetLabel(1,3); SetLabel(3,3); SetLabel(4,3); SetLabel(5,3); SetLabel(6,3);
			break;
			case 3: 
				SetLabel(3,2); 
				SetLabel(1,3); SetLabel(2,3); SetLabel(4,3); SetLabel(5,3); SetLabel(6,3);
			break;
			case 4: 
				SetLabel(4,2); 
				SetLabel(1,3); SetLabel(2,3); SetLabel(3,3); SetLabel(5,3); SetLabel(6,3);
			break;
			case 5: 
				SetLabel(5,2); 
				SetLabel(1,3); SetLabel(2,3); SetLabel(3,3); SetLabel(4,3); SetLabel(6,3);
			break;
			case 6: 
				SetLabel(6,2); 
				SetLabel(1,3); SetLabel(2,3); SetLabel(3,3); SetLabel(4,3); SetLabel(5,3);
			break;
		}
	}

	SetClockTimes();
}

void CWCCDlg::SetClockTimes()
{
	lblClock1.SetWindowText(clock1.GetTime().c_str());
	lblClock2.SetWindowText(clock2.GetTime().c_str());
	lblClock3.SetWindowText(clock3.GetTime().c_str());
	lblClock4.SetWindowText(clock4.GetTime().c_str());
	lblClock5.SetWindowText(clock5.GetTime().c_str());
	lblClock6.SetWindowText(clock6.GetTime().c_str());
}

void CWCCDlg::SetLabel(int clock, int status)
{
	switch (clock) {
	case 1: 
		clock1.SetStatus(status);
		if (clock1.IsOver()) {lblPressed1.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed1.SetWindowText("ready"); break;
			case 1: lblPressed1.SetWindowText("stopped"); break;
			case 2: lblPressed1.SetWindowText("running"); break;
			case 3: lblPressed1.SetWindowText("waiting"); break;
			case 4: lblPressed1.SetWindowText("flagged"); break;
		}
	break;
	case 2: 
		clock2.SetStatus(status);
		if (clock2.IsOver()) {lblPressed2.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed2.SetWindowText("ready"); break;
			case 1: lblPressed2.SetWindowText("stopped"); break;
			case 2: lblPressed2.SetWindowText("running"); break;
			case 3: lblPressed2.SetWindowText("waiting"); break;
			case 4: lblPressed2.SetWindowText("flagged"); break;
		}
	break;
	case 3: 
		clock3.SetStatus(status);
		if (clock3.IsOver()) {lblPressed3.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed3.SetWindowText("ready"); break;
			case 1: lblPressed3.SetWindowText("stopped"); break;
			case 2: lblPressed3.SetWindowText("running"); break;
			case 3: lblPressed3.SetWindowText("waiting"); break;
			case 4: lblPressed3.SetWindowText("flagged"); break;
		}
	break;
	case 4: 
		clock4.SetStatus(status);
		if (clock4.IsOver()) {lblPressed4.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed4.SetWindowText("ready"); break;
			case 1: lblPressed4.SetWindowText("stopped"); break;
			case 2: lblPressed4.SetWindowText("running"); break;
			case 3: lblPressed4.SetWindowText("waiting"); break;
			case 4: lblPressed4.SetWindowText("flagged"); break;
		}
	break;
	case 5: 
		clock5.SetStatus(status);
		if (clock5.IsOver()) {lblPressed5.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed5.SetWindowText("ready"); break;
			case 1: lblPressed5.SetWindowText("stopped"); break;
			case 2: lblPressed5.SetWindowText("running"); break;
			case 3: lblPressed5.SetWindowText("waiting"); break;
			case 4: lblPressed5.SetWindowText("flagged"); break;
		}
	break;
	case 6: 
		clock6.SetStatus(status);
		if (clock6.IsOver()) {lblPressed6.SetWindowText("flagged"); return;}
		switch (status) {
			case 0: lblPressed6.SetWindowText("ready"); break;
			case 1: lblPressed6.SetWindowText("stopped"); break;
			case 2: lblPressed6.SetWindowText("running"); break;
			case 3: lblPressed6.SetWindowText("waiting"); break;
			case 4: lblPressed6.SetWindowText("flagged"); break;
		}
	break;
	}
}

void CWCCDlg::SetTitle()
{
	string title = "GameClock - ";
	switch (m_iGlobalStatus) {
		case 0: title += "READY"; btnPause.SetWindowText("&Run"); btnNext.EnableWindow(false); break;
		case 1: title += "RUNNING"; btnPause.SetWindowText("&Pause"); btnNext.EnableWindow(true); break;
		case 2: title += "PAUSED"; btnPause.SetWindowText("Un&pause"); btnNext.EnableWindow(false); break;
		case 3: title += "EVERYONE IS FLAGGED!"; btnPause.SetWindowText("---"); btnNext.EnableWindow(false); break;	
	}
    SetWindowText(title.c_str());
}

void CWCCDlg::RunClock()
{
	switch (m_iRunningClock) {
		case 1: clock1.Run(); break;
		case 2: clock2.Run(); break;
		case 3: clock3.Run(); break;
		case 4: clock4.Run(); break;
		case 5: clock5.Run(); break;
		case 6: clock6.Run(); break;
	}
}

void CWCCDlg::StopClock()
{
	switch (m_iRunningClock) {
		case 1: clock1.Stop(); break;
		case 2: clock2.Stop(); break;
		case 3: clock3.Stop(); break;
		case 4: clock4.Stop(); break;
		case 5: clock5.Stop(); break;
		case 6: clock6.Stop(); break;
	}
}

void CWCCDlg::IncClock()
{
	switch (m_iRunningClock) {
		case 1: clock1.Inc(); break;
		case 2: clock2.Inc(); break;
		case 3: clock3.Inc(); break;
		case 4: clock4.Inc(); break;
		case 5: clock5.Inc(); break;
		case 6: clock6.Inc(); break;
	}
}

bool CWCCDlg::IsOverClock()
{
	switch (m_iRunningClock) {
		case 1: return clock1.IsOver();
		case 2: return clock2.IsOver();
		case 3: return clock3.IsOver();
		case 4: return clock4.IsOver();
		case 5: return clock5.IsOver();
		case 6: return clock6.IsOver();
	}
	return false;
}

void CWCCDlg::PauseAll()
{
	clock1.Pause();
	clock2.Pause();
	clock3.Pause();
	clock4.Pause();
	clock5.Pause();
	clock6.Pause();
}

void CWCCDlg::UnpauseAll()
{
	clock1.Unpause();
	clock2.Unpause();
	clock3.Unpause();
	clock4.Unpause();
	clock5.Unpause();
	clock6.Unpause();
}

void CWCCDlg::StopAll()
{
	clock1.Stop();
	clock2.Stop();
	clock3.Stop();
	clock4.Stop();
	clock5.Stop();
	clock6.Stop();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Mainly generated or copied functions
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CWCCDlg::PreTranslateMessage(MSG* pMsg) 
{
	bool b1 = false, b2 = false, b3 = false;
	if (pMsg->message == WM_KEYDOWN) {
		if (clock1.IsSwitchKey(pMsg->wParam)) {
			OnBnClickedPress1();
			b1 = true;
		}
		if (clock2.IsSwitchKey(pMsg->wParam)) {
			OnBnClickedPress2();
			b2 = true;
		}
		if (pMsg->wParam == VK_SPACE && m_iGlobalStatus != 2) {  // only during PAUSE you can enter spaces to player names
			OnBnClickedNext();
			b3 = true;
		}
		if (b1 || b2 || b3)
			return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CWCCDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType,cx,cy);
	Recalculate();
	UPDATE_EASYSIZE;
	if (!m_bInitialized)
		return;
	SetFontSize();
}

void CWCCDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	CDialog::OnSizing(fwSide,pRect);
	EASYSIZE_MINSIZE(485,340,fwSide,pRect);
}

HBRUSH CWCCDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
	switch (nCtlColor) {
	case CTLCOLOR_EDIT: case CTLCOLOR_MSGBOX: case CTLCOLOR_STATIC: {
		switch (pWnd->GetDlgCtrlID()) {
		case LBL_CLOCK1: 
			pDC->SetTextColor(RGB(0,0,0)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush1;
			break;
		case LBL_CLOCK2: 
			pDC->SetTextColor(RGB(255,255,255)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush2;
			break;
		case LBL_CLOCK3: 
			pDC->SetTextColor(RGB(0,0,0)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush3;
			break;
		case LBL_CLOCK4: 
			pDC->SetTextColor(RGB(255,255,255)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush4;
			break;
		case LBL_CLOCK5: 
			pDC->SetTextColor(RGB(0,0,0)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush5;
			break;
		case LBL_CLOCK6: 
			pDC->SetTextColor(RGB(255,255,255)); 
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush6;
			break;
		case LBL_PRESSED1:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED1)), true);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush2;
			break;
		case LBL_PRESSED2:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED2)), false);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush1;
			break;
		case LBL_PRESSED3:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED3)), true);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush4;
			break;
		case LBL_PRESSED4:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED4)), false);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush3;
			break;
		case LBL_PRESSED5:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED5)), true);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush6;
			break;
		case LBL_PRESSED6:
			SetColor(pDC, GetTxt(*GetDlgItem(LBL_PRESSED6)), false);
			pDC->SetBkMode(TRANSPARENT); 
			hbr = m_brush5;
		break;
		}
	}}
	return hbr;
}

void CWCCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon. For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CWCCDlg::OnPaint()
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags the minimized window.
HCURSOR CWCCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Font size, position and color functions
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CWCCDlg::SetFontSize()
{
	if (!lblClock1)
		return;
	LOGFONT lf;
	// clear out structure
	memset(&lf, 0, sizeof(LOGFONT));     
	// request a 12-pixel-height font
	CRect rect;
	lblClock1.GetWindowRect(rect);
	
	lf.lfHeight = rect.Width() / 3;
	if (rect.Height() < rect.Width() / 4) 
		lf.lfHeight = rect.Height() / 2;
	// request a face name "Arial"
	_tcsncpy_s(lf.lfFaceName, LF_FACESIZE, _T("Arial"), 7);
	// create the font
	HFONT hfont = ::CreateFontIndirect(&lf);  

	// Convert the HFONT to CFont*.
	CFont* pfont = CFont::FromHandle(hfont);

	lblClock1.SetFont(pfont);
	lblClock2.SetFont(pfont);
	lblClock3.SetFont(pfont);
	lblClock4.SetFont(pfont);
	lblClock5.SetFont(pfont);
	lblClock6.SetFont(pfont);

	// for labels ("running" etc)
	lf.lfHeight = 22;
	lf.lfWidth = 11;
	lf.lfWeight = FW_BOLD;
	hfont = ::CreateFontIndirect(&lf); 
	pfont = CFont::FromHandle(hfont);

	lblPressed1.SetFont(pfont);
	lblPressed2.SetFont(pfont);
	lblPressed3.SetFont(pfont);
	lblPressed4.SetFont(pfont);
	lblPressed5.SetFont(pfont);
	lblPressed6.SetFont(pfont);
}

void CWCCDlg::Recalculate()
{
	if (GetDlgItem(LBL_CLOCK1) == NULL) {
		return;
	}

	CRect client; 
	GetClientRect(client);

	//Heights
	int hFull = client.Height()-165;
	int hHalf = hFull/2-30;
	int hClk = m_iPlayers<4 ? hFull : hHalf;
	int hLbl = 30, hBtn = 25, hEdt = 25;

	//Widths
	int wFull = client.Width()-20;
	int wHalf = wFull/2;
	int wThird = wFull/3;
	int wClk = m_iPlayers==1 ? wFull : m_iPlayers==2 || m_iPlayers==4 ? wHalf : wThird;
	int wLbl = wClk;
	int wBtn = 25;
	int wEdt = wClk-30;

	//Positions
	//1,3,5,6 OR 2,4 clocks
	//
	// 1 2 3     1 7 
	// 4 5 6     4 8
	
	//Lefts
	int l1Clk = client.left+10;
	int l1Lbl = l1Clk;
	int l1Btn = l1Clk;
	int l1Edt = l1Clk+30;
	int l2Clk = client.Width()/3+5;
	int l2Lbl = l2Clk;
	int l2Btn = l2Clk;
	int l2Edt = l2Clk+30;
	int l3Clk = client.Width()/3*2;
	int l3Lbl = l3Clk;
	int l3Btn = l3Clk;
	int l3Edt = l3Clk+30;
	int l4Clk = l1Clk;
	int l4Lbl = l1Lbl;
	int l4Btn = l1Btn;
	int l4Edt = l1Edt;
	int l5Clk = l2Clk;
	int l5Lbl = l2Lbl;
	int l5Btn = l2Btn;
	int l5Edt = l2Edt;
	int l6Clk = l3Clk;
	int l6Lbl = l3Lbl;
	int l6Btn = l3Btn;
	int l6Edt = l3Edt;
	int l7Clk = client.Width()/2;
	int l7Lbl = l7Clk;
	int l7Btn = l7Clk;
	int l7Edt = l7Clk+30;
	int l8Clk = l7Clk;
	int l8Lbl = l7Lbl;
	int l8Btn = l7Btn;
	int l8Edt = l7Edt;

	//Tops
	int t1Clk = client.top+45;
	int t1Lbl = t1Clk-35;
	int t1Btn = client.top+50+hClk;
	int t1Edt = t1Btn;
	int t2Clk = t1Clk;
	int t2Lbl = t1Lbl;
	int t2Btn = t1Btn;
	int t2Edt = t1Edt;
	int t3Clk = t1Clk;
	int t3Lbl = t1Lbl;
	int t3Btn = t1Btn;
	int t3Edt = t1Edt;
	int t4Clk = client.top+hHalf+110;
	int t4Lbl = t4Clk-35;
	int t4Btn = client.top+2*hHalf+110;
	int t4Edt = t4Btn;
	int t5Clk = t4Clk;
	int t5Lbl = t4Lbl;
	int t5Btn = t4Btn;
	int t5Edt = t4Edt;
	int t6Clk = t4Clk;
	int t6Lbl = t4Lbl;
	int t6Btn = t4Btn;
	int t6Edt = t4Edt;
	int t7Clk = t1Clk;
	int t7Lbl = t1Lbl;
	int t7Btn = t1Btn;
	int t7Edt = t1Edt;
	int t8Clk = t4Clk;
	int t8Lbl = t4Lbl;
	int t8Btn = t4Btn;
	int t8Edt = t4Edt;

    if (m_iPlayers == 2 || m_iPlayers == 4) {   // position 1,7,4,8
		GetDlgItem(LBL_CLOCK1)->MoveWindow(l1Clk,t1Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED1)->MoveWindow(l1Lbl,t1Lbl,wLbl,hLbl);
		GetDlgItem(BTN_1)->MoveWindow(l1Btn,t1Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER1)->MoveWindow(l1Edt,t1Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK2)->MoveWindow(l7Clk,t7Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED2)->MoveWindow(l7Lbl,t7Lbl,wLbl,hLbl);
		GetDlgItem(BTN_2)->MoveWindow(l7Btn,t7Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER2)->MoveWindow(l7Edt,t7Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK3)->MoveWindow(l4Clk,t4Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED3)->MoveWindow(l4Lbl,t4Lbl,wLbl,hLbl);
		GetDlgItem(BTN_3)->MoveWindow(l4Btn,t4Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER3)->MoveWindow(l4Edt,t4Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK4)->MoveWindow(l8Clk,t8Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED4)->MoveWindow(l8Lbl,t8Lbl,wLbl,hLbl);
		GetDlgItem(BTN_4)->MoveWindow(l8Btn,t8Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER4)->MoveWindow(l8Edt,t8Edt,wEdt,hEdt);
	} else { // positions 1,2,3,4,5,6
		GetDlgItem(LBL_CLOCK1)->MoveWindow(l1Clk,t1Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED1)->MoveWindow(l1Lbl,t1Lbl,wLbl,hLbl);
		GetDlgItem(BTN_1)->MoveWindow(l1Btn,t1Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER1)->MoveWindow(l1Edt,t1Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK2)->MoveWindow(l2Clk,t2Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED2)->MoveWindow(l2Lbl,t2Lbl,wLbl,hLbl);
		GetDlgItem(BTN_2)->MoveWindow(l2Btn,t2Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER2)->MoveWindow(l2Edt,t2Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK3)->MoveWindow(l3Clk,t3Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED3)->MoveWindow(l3Lbl,t3Lbl,wLbl,hLbl);
		GetDlgItem(BTN_3)->MoveWindow(l3Btn,t3Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER3)->MoveWindow(l3Edt,t3Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK4)->MoveWindow(l4Clk,t4Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED4)->MoveWindow(l4Lbl,t4Lbl,wLbl,hLbl);
		GetDlgItem(BTN_4)->MoveWindow(l4Btn,t4Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER4)->MoveWindow(l4Edt,t4Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK5)->MoveWindow(l5Clk,t5Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED5)->MoveWindow(l5Lbl,t5Lbl,wLbl,hLbl);
		GetDlgItem(BTN_5)->MoveWindow(l5Btn,t5Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER5)->MoveWindow(l5Edt,t5Edt,wEdt,hEdt);

		GetDlgItem(LBL_CLOCK6)->MoveWindow(l6Clk,t6Clk,wClk,hClk);
		GetDlgItem(LBL_PRESSED6)->MoveWindow(l6Lbl,t6Lbl,wLbl,hLbl);
		GetDlgItem(BTN_6)->MoveWindow(l6Btn,t6Btn,wBtn,hBtn);
		GetDlgItem(EDT_PLAYER6)->MoveWindow(l6Edt,t6Edt,wEdt,hEdt);
	}
	SetFontSize();
	Invalidate(); UpdateWindow();
}

void CWCCDlg::SetColor(CDC* pDC, std::string str, bool odd)
{
	COLORREF color;
	if (str=="ready")           color = 0x3399FF;  //orange
	if (str=="running")         color = 0x009900;  //green
	if (str=="stopped")         color = 0x0000FF;  //red
	if (str=="waiting")         color = 0xFF8000;  //blue
	if (str=="flagged" && odd)  color = 0xFFFFFF;  //white
	if (str=="flagged" && !odd) color = 0x000000;  //black

	pDC->SetTextColor(color);
}
