// WCCDlg.h : header file
#pragma once
#include "afxwin.h"

// CWCCDlg dialog
class CWCCDlg : public CDialog
{
	DECLARE_EASYSIZE 
public:
	CWCCDlg(CWnd* pParent = NULL);	// standard constructor
	enum { IDD = IDD_WCC_DIALOG };
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
protected:
	HICON m_hIcon;
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CButton btnPress1;
	CButton btnPress2;
	CButton btn1;
	CButton btn2;
	CButton btn3;
	CButton btn4;
	CButton btn5;
	CButton btn6;
	CButton btnPause;
	CButton btnNext;
	CButton btnReset;
	CEdit edtTime;
	CEdit edtInc;
	CEdit edtPlayer1;
	CEdit edtPlayer2;
	CEdit edtPlayer3;
	CEdit edtPlayer4;
	CEdit edtPlayer5;
	CEdit edtPlayer6;
	CButton chkBronstein;
	CStatic lblClock1;
	CStatic lblClock2;
	CStatic lblClock3;
	CStatic lblClock4;
	CStatic lblClock5;
	CStatic lblClock6;
	int m_iRunningClock;    //0 means all are flagged
	int m_iPlayers;         //1..6, default 2
	CButton chkSound;
	bool m_bInitialized;
	bool m_bChanged;		//time settings were changed
	CButton btnMoretime;
	CButton btnPlayers;
	int m_iGlobalStatus;	//0=READY, 1=RUNNING, 2=PAUSED, 3=ALL FLAGGED
	CStatic lblPressed1;
	CStatic lblPressed2;
	CStatic lblPressed3;
	CStatic lblPressed4;
	CStatic lblPressed5;
	CStatic lblPressed6;
	int m_iTimer1,m_iTimer2,m_iTimer3,m_iTimer4,m_iTimer5,m_iTimer6;
	CBrush m_brush1,m_brush2,m_brush3,m_brush4,m_brush5,m_brush6;
	CFont m_font;
	void SetFontSize();
	//sets clock to ready/running and other clocks to stopped/waiting if they are not flagged
	void SetClockLabels();
	void SetLabel(int clock, int status);
	void SetTitle();
	void RunClock();
	void StopClock();
	void IncClock();
	bool IsOverClock();
	void PauseAll();
	void UnpauseAll();
	void StopAll();
	void GetNextPlayer();
	void SetClockTimes();
	void Recalculate();
	void SetColor(CDC* pDC, std::string str, bool odd);

	afx_msg void OnBnClickedReset();
	afx_msg void OnBnClickedPause();
	afx_msg void OnBnClickedNext();
	afx_msg void OnBnClickedMoretime();
	afx_msg void OnBnClickedPlayers();
	afx_msg void OnBnClickedPress1();
	afx_msg void OnBnClickedPress2();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClicked1();
	afx_msg void OnBnClicked2();
	afx_msg void OnBnClicked3();
	afx_msg void OnBnClicked4();
	afx_msg void OnBnClicked5();
	afx_msg void OnBnClicked6();
	afx_msg void OnBnClickedBronstein();
	afx_msg void OnEnChangeInc();
	afx_msg void OnEnChangeTime();
};

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()
};

// CMoretimeDlg dialog
class CMoretimeDlg : public CDialog
{
public:
	CMoretimeDlg(int mp=2);
	int GetWho() {return iWho;};
	int GetMoretime() {return iTime;};
	enum { IDD = DLG_MORETIME };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedOk();
private:
	int iWho;	//0=all
	int iTime;	//moretime in s
	int iMaxPlayers;
public:
	CButton chkAll;
	CButton chkSpecific;
	CComboBox cmbPlayer;
	CEdit edtMin;
	CEdit edtS;
	afx_msg void OnCbnSelchangePlayer();
};

// CPlayersDLg dialog
class CPlayersDlg : public CDialog
{
public:
	CPlayersDlg(int p=2);
	int GetPlayers() {return iPlayers;};
	enum { IDD = DLG_PLAYERS };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
private:
	int iPlayers;
public:
	CButton chk1;
	CButton chk2;
	CButton chk3;
	CButton chk4;
	CButton chk5;
	CButton chk6;
	afx_msg void OnBnClickedOk();
};
